//Breadth-first Search
//Searches a tree by level

//Return things in order:
//1,2,3,4,5,6
const BinaryTreeNode = require("../structures/binary_tree");

const Node = require("../structures/binary_tree");
//in thousands
const ceo = new Node(1000);
const pres = ceo.addLeft(500);
const coo = ceo.addRight(500);

const vpOfToys = pres.addRight(450);
vpOfToys.addLeft(250);
vpOfToys.addRight(280);

const vpOfLuck = pres.addLeft(400);
vpOfLuck.addLeft(220);
vpOfLuck.addRight(260);

const vpOfMeetings = coo.addLeft(380);
vpOfMeetings.addLeft(210);
vpOfMeetings.addRight(220);

const vpOfVPs = coo.addRight(350);
vpOfVPs.addLeft(230);
vpOfVPs.addRight(240);

const Queue = require("../structures/queue");
const q = new Queue();

q.enqueue(ceo);
while(q.count > 0){
  const thisNode = q.dequeue();
  console.log(thisNode.value);
  if(thisNode.left) q.enqueue(thisNode.left);
  if(thisNode.right) q.enqueue(thisNode.right);
}
