//Depth-first Search (DFS)
//down the left side, back up then back down until done
//snaking left to right

const BinaryTreeNode = require("../structures/binary_tree");

const root = new BinaryTreeNode(0);
const l1 = root.addLeft(1);
const r1 = root.addRight(2);
l1.addLeft(3);
l1.addRight(4);
r1.addLeft(5);
r1.addRight(6);

//Types of DFS:
//pre-order
//in-order
//post-order
const dfs = function(node){
  if(node){
    console.log(node.value);//post-order
    dfs(node.left);
    dfs(node.right);
  }
}
dfs(root);
