const salaries = [
  {user: "danz0", salary : 210},
  {user:"sampus", salary : 220},
  {user:"sallamamba", salary : 220},
  {user:"akeela", salary : 230},
  {user:"dwonx", salary : 240},
  {user:"twixl", salary : 250},
  {user:"flerp", salary : 260},
  {user:"twitchx", salary : 280},
  {user:"dkkk3k2k2", salary : 350},
  {user:"plinth", salary : 380},
  {user:"j0newa", salary : 400},
  {user:"klifffff", salary : 450},
  {user:"perplz", salary : 500},
  {user:"x", salary : 500},
  {user:"zed", salary : 1000}
]
// const findEmployeeBySalary = function(target){
//   let max = salaries.length-1, min = 0;
//   let found = false;
//   let passes = 1;
//   while(!found){
//     console.log("Passes: ", passes);
//     let mid = min + parseInt((max - min)/2);
//     let possible = salaries[mid];
//     if(possible.salary === target) return salaries[mid];
//     if(possible.salary < target) min = mid + 1;
//     else max = mid - 1;
//     if(max < min) break;
//     passes++;
//   }
//   //if we made it here... we lost
//   return null;
// }
const salaryTable = {};
//preload every object into a dictionary
//using the salary as a key
for(let record of salaries){
  const key = record.salary;
  if(salaryTable[key]){
    if(Array.isArray(salaryTable[key])){
      salaryTable[key].push(record);
    }else{
      salaryTable[key] = [record, salaryTable[key]];
    }
  }else{
    salaryTable[key] = record;
  }
}
const findEmployeeBySalary = function(target){
  return salaryTable[target] ? salaryTable[target] : null;
}
console.log(findEmployeeBySalary(500))
