const salaries = [
  {user: "danz0", salary : 210},
  {user:"sampus", salary : 220},
  {user:"sallamamba", salary : 220},
  {user:"akeela", salary : 230},
  {user:"dwonx", salary : 240},
  {user:"twixl", salary : 250},
  {user:"flerp", salary : 260},
  {user:"twitchx", salary : 280},
  {user:"dkkk3k2k2", salary : 350},
  {user:"plinth", salary : 380},
  {user:"j0newa", salary : 400},
  {user:"klifffff", salary : 450},
  {user:"perplz", salary : 500},
  {user:"x", salary : 520},
  {user:"zed", salary : 1000}
]
const Node = require("../structures/binary_search_tree");
const buildTree = function(ary, min, max){
  if(max < min) return null;
  const mid = parseInt((min + max) / 2);
  const node = new Node(ary[mid]);
  node.addLeft(buildTree(ary, min, mid-1));
  node.addRight(buildTree(ary, mid + 1, max));
  return node;
}
const tree = buildTree(salaries, 0, salaries.length -1);

const dfs = node => {
  if(node){
    dfs(node.left);
    console.log(node.value);
    dfs(node.right);
  }
}
dfs(tree);
