const Node = require("../structures/binary_tree");
//in thousands
const ceo = new Node(1000);
const pres = ceo.addLeft(500);
const coo = ceo.addRight(500);

const vpOfToys = pres.addRight(350);
vpOfToys.addLeft(220);
vpOfToys.addRight(220);

const vpOfLuck = pres.addLeft(200);
vpOfLuck.addLeft(220);
vpOfLuck.addRight(220);

const vpOfMeetings = coo.addLeft(350);
vpOfMeetings.addLeft(220);
vpOfMeetings.addRight(220);

const vpOfVPs = coo.addRight(200);
vpOfVPs.addLeft(220);
vpOfVPs.addRight(220);


const isSymmetric = function(tree){
  const Queue = require("../structures/queue");
  const q = new Queue();

  //we can skip the CEO, she's on top
  q.enqueue(ceo.left);
  q.enqueue(ceo.right);

  while(q.count > 0){
    const left = q.dequeue();
    const right = q.dequeue();
    console.log(`Comparing ${left.value} to ${right.value}`)

    if(left.value != right.value) return false;

    //enqueu left and right child nodes
    if(left.left) q.enqueue(left.left);
    if(right.right) q.enqueue(right.right);
    if(right.left) q.enqueue(right.left);
    if(left.right) q.enqueue(left.right);
  }
  //if we made it here we're good
  return true;
}

console.log(isSymmetric(ceo))
