//Graph
//A collection of values (vertexes) related to one another
//Relationships are called "edges"
//Edges can have a value too, as well as a direction

//Aside from arrays, *everything* we've been looking at so far
//***** is a graph ******
//LinkedLists
//Trees, Binary Trees, BSTs
//Queues
//Stacks
//Heaps

class Vertex{
  constructor(val){
    this.value = val;
    this.edges = [];
  }
  to(toVertex, cost){
    this.edges.push({
      to: toVertex,
      cost: cost
    });
    return this;
  }
}
const A = new Vertex("A");
const B = new Vertex("B");
const C = new Vertex("C");
const D = new Vertex("D");

A.to(B, 4);
B.to(C, 5);
C.to(D, 10);
D.to(A, 9);

const Hash = require("./hash");
const visited = new Hash();
const traverse = function(node){
  for(let e of node.edges){
    if(!visited.contains(node.value)){
      //calcs
      console.log(node);
      visited.add(node.value);
      traverse(e.to);
    }
  }
}
traverse(A);
