//HashTable (or HashSet) - the key is a hash of the value that's being stored.

//Great for remembering things! O(1) contains and lookups
const HashTable = function(){
  let count = 0;
  let store = [];
  let buckets = [];

  const createHash = function(val){
    //do not do this!
    return val.toString();
  };
  const add = function(val){
    count++;
    //create the hash
    const idx = createHash(val);
    store[idx] = val;
  };
  const contains = function(val){
    const idx = createHash(val);
    return store[idx] !== undefined;
  };
  const remove = function(key){
    count--;
    const idx = createHash(key);
    delete store[idx];
  }
  return {
    add : add,
    remove: remove,
    count: count,
    contains: contains
  }
}
module.exports = HashTable;

const hash =  new HashTable();
hash.add(1);
hash.add(2);
console.log(hash.contains(2));
