// Given a 2d grid map of '1's (land) and '0's (water), count the number of islands. An island is surrounded by water and is formed by connecting adjacent lands horizontally or vertically. You may assume all four edges of the grid are all surrounded by water.
//
// Example 1:
//
// 11110
// 11010
// 11000
// 00000
// Answer: 1
//
// Example 2:
//
// 11000
// 11000
// 00100
// 00011
// Answer: 3

//NAILED IT!!!! Mostly because I used my time wisely to check my WORK!
//??? Did I really?

//remember last row and refer to column location
const getIslandCount = function(rows){
	if(!rows && rows.length < 2) throw new Error("Invalid ocean");

	let islandCount = 0;
	let lastRow = null;

	for(let row of rows){
    if(row.length < 2) throw new Error("Invalid islands");

		let lastCoordinate = null;
		for(let i = 0; i < row.length; i++){
			let thisCoordinate = row[i];
			let thisIsLand = thisCoordinate === 1;
			let continuingIsland = false;

			if(thisIsLand && lastCoordinate === 1){
				continuingIsland = true;
      }else if(lastRow && lastRow[i] === 1){
      	continuingIsland = true;
      }
      if(thisIsLand && !continuingIsland){
      	islandCount++;
      }

			lastCoordinate = thisCoordinate;
    }
		lastRow = row;
  }
  return islandCount;
}


const ocean = [
  [1,1,1,1,0],
  [1,1,0,1,0],
  [1,1,0,0,0],
  [0,0,0,0,0]
];
const ocean2 = [
  [1,1,0,0,0],
  [1,1,0,0,0],
  [0,0,1,0,0],
  [0,0,0,1,1]
];
const ocean3 = [
  [1,1,0,0,0],
  [1,1,0,0,0],
  [0,0,1,0,1],
  [0,0,1,1,1]
];
const res = getIslandCount(ocean3);
console.log(res);
