const meetings = [
  [13,14],
  [12,12.5],
  [13,15],
  [14,16],
  [13,17]
];

const meetingAudit = function(meetings){
  let maxDuration = 0;
  let minDuration = Infinity;
  for(let m of meetings){
    const duration = m[1] - m[0];
    maxDuration = Math.max(duration, maxDuration);
    minDuration = Math.min(duration, minDuration);
  }
  return {max: maxDuration, min: minDuration};
}
console.log(meetingAudit(meetings));
