//Binary Search Tree
//Just like a binary tree but with the additional rule
//that all left values must be LESS than their parent
//and all right values must be GREATER
const BinaryTreeNode = require("./binary_tree");
//build out of an array?
//sort the array
class BinarySearchTreeNode extends BinaryTreeNode{
  constructor(val){
    super(val);
  }
  addRight(val){
    if(val < this.value) throw new Error("Invalid left");
    return super.addRight(val);
  }
  addRightNode(node){
    if(node.value < this.value) throw new Error("Invalid right: ", node.value);
    this.right = node;
    return node;
  }
  addLeft(val){
    if(val > this.value) throw new Error("Invalid left");
    return super.addLeft(val);
  }
  addLeftNode(node){
    if(node.value > this.value) throw new Error("Invalid left");
    this.left = node;
    return node;
  }
}
module.exports = BinarySearchTreeNode;
