//Queue
//First in, First out (FIFO)
//Just like getting in line for the movies
//First in line is first to go in

const LinkedList = require("./linked_list");
class Queue{
  constructor(){
    this.count = 0;
    this.list = new LinkedList();
  }
  enqueue(val){
    this.count++;
    //adding to the bottom of the queue
    this.list.append(val);
  }
  dequeue(){
    let out = this.peek();
    if(out){
      this.count--;
      this.list.remove(this.list.head);
    }
    return out;
  }
  peek(){
    return this.list.head ? this.list.head.value : null;
  }
}

module.exports = Queue;
