//Tree
//Like a linked list but with many "nexts"
//which you can also think of as children

//Has a single root and 0..n children
//root
// - child
//    --child
// - child
// - child

class TreeNode{
  constructor(val){
    this.value = val;
    this.children = [];
  }
  addChild(val){
    const newNode = new TreeNode(val);
    this.children.push(newNode);
    return newNode;
  }
}
module.exports = TreeNode;
